/*
 *	dictit.h
 *
 *	The Dictionary needs a dedicated Iterator class.
 *
 *	(C) Copyright 1994-1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef	_OPaC_DICTIT_H_
#define	_OPaC_DICTIT_H_

#ifndef _OPaC_OPEXPORT_H_
#include <OPaC/opexport.h>
#endif

/****************************************************************/

#ifndef _OPaC_ITERATOR_H_
#include <OPaC/iterator.h>
#endif

#ifndef _OPaC_CONTAINER_H_
#include <OPaC/container.h>
#endif

/****************************************************************/

/*
 *	Dictionary iterator.
 */

class OP_PUBLIC OPDictIterator : public OPIterator
{
	friend class OPDict;
	
protected:
	OPDict::Element*	current;
	
protected:
	OPDictIterator ();
	virtual ~ OPDictIterator ();
	
	virtual void StoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	virtual void RestoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	
	virtual void NotifyInsert (OPDict::Element* elem);
	virtual void NotifyRemove (OPDict::Element* elem);
	
public:
	virtual void Delete ();								/* OVERRIDDEN */
	
	//	The iterator exports following overridden methods :
	
	virtual Bool First ();								/* OVERRIDDEN */
	virtual Bool Last ();								/* OVERRIDDEN */
	
	virtual Bool Next (Count move = 1);					/* OVERRIDDEN */
	virtual Bool Prev (Count move = 1);					/* OVERRIDDEN */
	
	virtual Bool Get (OPObjectOut, Count index = 0);	/* OVERRIDDEN */
	virtual Bool GetKey (OPObjectOut, Count index = 0);
	virtual Bool GetValue (OPObjectOut, Count index = 0);
	
	OP_DEFINE_CLASS (OPDictIterator, OPIterator);
};

/****************************************************************/

#endif /* _OPaC_LISTIT_H_ */
