/*
 *	iconset.h
 *
 *	The Icon Set class draws several icons side by side.
 *
 *	(C) Copyright 1997, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef _OPaC_ICONSET_H_
#define	_OPaC_ICONSET_H_

#ifndef _OPaC_OPEXPORT_H_
#include <OPaC/opexport.h>
#endif

#ifndef _OPaC_ICON_H_
#include <OPaC/icon.h>
#endif

/****************************************************************/

/*
 *	Icon Set class. An icon set is also a kind of button.
 */

class OP_PUBLIC OPIconSet : public OPControl
{
	
private:
	OPIconArray			icons;					//	array of icons
	
protected:
	OPIconSet ();
	virtual ~ OPIconSet ();
	
	virtual void StoreInstance (OPStorageIn storage);	/* OVERRIDDEN */
	virtual void RestoreInstance (OPStorageIn storage);	/* OVERRIDDEN */

	virtual void UpdateGeometry ();
	
public:
	virtual void Delete ();								/* OVERRIDDEN */
	
	virtual Bool InsertIcon (Count index, OPIconIn icon);
	virtual Bool InsertIcon (Count index, OPLookIcon icon);
	virtual Bool InsertIcon (Count index, OPLookIcon normal, OPLookIcon press, OPLookIcon hilite, OPLookIcon dim, OPLookIcon hover);
	virtual Bool RemoveIcon (Count index);
	
	//	Inherited methods :
	
	virtual void GetMinSize (OPCoordOut dx, OPCoordOut dy) const;/* OVERRIDDEN */
	virtual void GetMaxSize (OPCoordOut dx, OPCoordOut dy) const;/* OVERRIDDEN */
	
	OP_DEFINE_CLASS (OPIconSet, OPControl);
};

/****************************************************************/

#endif /* _OPaC_ICONSET_H_ */
