/*
 *	icostyle.h
 *
 *	Defines the icon styles.
 *
 *	(C) Copyright 1994-1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef	_OPaC_ICOSTYLE_H_
#define	_OPaC_ICOSTYLE_H_

/****************************************************************/

/*
 *	The OPaC look manager provides a collection of icons
 *	which are commonly used for the user interface. They
 *	can be accessed using the following indexes :
 */

#define	DEF_ENUM_BEGIN(T)	enum T {
#define	DEF_ENUM(T,n)		T = n
#define	DEF_ENUM_END(T)		};

#include <OPaC/enum/lookicon.h>

#define	OP_ICON_NUM		( ((Card32)(OP_ICON_LINE_0) & 0x00FF) + 1	\
						+ ((Card32)(OP_ICON_LINE_1) & 0x00FF) + 1	\
						+ ((Card32)(OP_ICON_LINE_2) & 0x00FF) + 1	\
						+ ((Card32)(OP_ICON_LINE_3) & 0x00FF) + 1	\
						+ ((Card32)(OP_ICON_LINE_4) & 0x00FF) + 1 )

OP_TYPEENUM (OPLookIcon);

/****************************************************************/

#endif /* _OPaC_ICOSTYLE_H_ */
