/*
 *	ieeemath.cxx
 *	
 *	The IEEE double cannot be saved as is, because its size is architecture
 *	dependent. That's why some portable format has been defined :
 *
 *	- 32-bit exponent + mantissa sign bit
 *	- 64-bit mantissa
 *	
 *	(C) Copyright 1994-1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#ifndef _OPaC_IEEEMATH_H_
#define	_OPaC_IEEEMATH_H_

#ifndef _OPaC_TYPES_H_
#include <OPaC/types.h>
#endif

extern void OP_PUBLIC OPaC_ExportDouble (double value, Card32& exponent, Card32* mantissa);
extern void OP_PUBLIC OPaC_ImportDouble (double& value, Card32 exponent, const Card32* mantissa);

#endif /* _OPaC_IEEEMATH_H_ */
