/*
 *	listreeit.cxx
 *
 *	The List Tree Iterator.
 *
 *	(C) Copyright 1998, Pierre ARNAUD, OPaC bright ideas
 *		CH-1437 SUSCEVAZ, Switzerland. All rights reserved.
 */

/******************************************************************************

  This file is part of the OPaC class library ("OPaC").

  OPaC is distributed with NO WARRANTY OF ANY KIND.  No author or distributor
  accepts any responsibility for the consequences of using it, or for whether
  it serves any particular purpose or works at all, unless he or she says so
  in writing. Refer to the OPaC Free Public License (the "License") for full
  details.

  Every copy of OPaC must include a copy of the License, normally in a plain
  ASCII text file named PUBLIC. The License grants you the right to copy,
  modify and redistribute OPaC, but only under certain conditions described
  in the License. The copyright notice and this notice must be preserved on
  all copies.

******************************************************************************/

#include <OPaC/listree.h>

/****************************************************************/

OP_IMPLEMENTATION_FILE;
OP_IMPLEMENT_CLASS (OPLisTreeIterator);

/****************************************************************/

OPLisTreeIterator::OPLisTreeIterator ()
{
	OP_METHOD (OPLisTreeIterator, 0);
}

OPLisTreeIterator::~OPLisTreeIterator ()
{
	OP_METHOD (~OPLisTreeIterator, 0);
}

void
OPLisTreeIterator::StoreInstance (OPStorageIn storage)
{
	OP_METHOD (StoreInstance, 1);
	OP_ARG (1, OPStorageIn, storage);
	
	super::StoreInstance (storage);
	
	static OPStorageSync info ("<OPLisTreeIterator>");
	
	storage << info;
	storage << OPStorageSync::begin;
	storage << OPStorageSync::end;
}

void
OPLisTreeIterator::RestoreInstance (OPStorageIn storage)
{
	OP_METHOD (RestoreInstance, 1);
	OP_ARG (1, OPStorageIn, storage);
	
	super::RestoreInstance (storage);
	
	storage >> OPStorageSync::type;
	storage >> OPStorageSync::begin;
	storage >> OPStorageSync::end;
}

void
OPLisTreeIterator::Delete ()
{
	OP_METHOD (Delete, 0);
}

Bool
OPLisTreeIterator::First ()
{
	OP_METHOD (First, 0);
	return FALSE;
}

Bool
OPLisTreeIterator::Last ()
{
	OP_METHOD (Last, 0);
	return FALSE;
}

Bool
OPLisTreeIterator::Next (Count move)
{
	OP_METHOD (Next, 1);
	OP_ARG (1, Count, move);
	
	return FALSE;
}

Bool
OPLisTreeIterator::Prev (Count move)
{
	OP_METHOD (Prev, 1);
	OP_ARG (1, Count, move);
	
	return FALSE;
}

Bool
OPLisTreeIterator::Get (OPObjectOut out, Count index)
{
	OP_METHOD (Get, 2);
	OP_ARG (1, OPObjectOut, out);
	OP_ARG (2, Count, index);
	
	return FALSE;
}
